<!-- 
 * @Description: 表单
 * @Author: huguodong 
 * @Date: 2023-12-15 15:45:28
!-->
<template>
  <div>
    <form-container v-model="visible" :title="`${departmentProps.opt}院系`" form-size="600px">
      <el-form
        ref="departmentFormRef"
        :rules="rules"
        :disabled="departmentProps.disabled"
        :model="departmentProps.record"
        :hide-required-asterisk="departmentProps.disabled"
        label-width="auto"
        label-suffix=" :"
      >
        <s-form-item label="院系编号" prop="code">
          <s-input v-model="departmentProps.record.code"></s-input>
        </s-form-item>
        <s-form-item label="院系名称" prop="name">
          <s-input v-model="departmentProps.record.name"></s-input>
        </s-form-item>
      </el-form>
      <template #footer>
        <el-button @click="onClose"> 取消 </el-button>
        <el-button v-show="!departmentProps.disabled" type="primary" @click="handleSubmit"> 确定 </el-button>
      </template>
    </form-container>
  </div>
</template>

<script setup lang="ts">
import { SysDepartment, userManageDepartmentApi } from "@/api";
import { FormOptEnum, SysDictEnum } from "@/enums";
import { required } from "@/utils/formRules";
import { FormInstance } from "element-plus";
import { useDictStore } from "@/stores/modules";

const visible = ref(false); //是否显示表单
const dictStore = useDictStore(); //字典仓库

// 表单参数
const departmentProps = reactive<FormProps.Base<any>>({
  opt: FormOptEnum.ADD,
  record: {},
  disabled: false
});

// 表单验证规则
const rules = reactive({
  code: [required("请输入院系编号")],
  name: [required("请输入院系名称")]
});

/**
 * 打开表单
 * @param props 表单参数
 */
function onOpen(props: FormProps.Base<SysDepartment.DepartmentInfo>) {
  Object.assign(departmentProps, props); //合并参数
  if (props.opt == FormOptEnum.ADD) {
    //如果是新增,设置默认值
    // departmentProps.record.sortCode = 99;
    // departmentProps.record.status = statusOptions[0].value;
  }
  visible.value = true; //显示表单
  if (props.record.id) {
    departmentProps.record = props.record;
    //如果传了id，就去请求api获取record

    userManageDepartmentApi.detail({ id: props.record.id }).then(res => {
      departmentProps.record = res.data;
    });
  }
}

// 提交数据（新增/编辑）
const departmentFormRef = ref<FormInstance>();
/** 提交表单 */
async function handleSubmit() {
  departmentFormRef.value?.validate(async valid => {
    if (!valid) return; //表单验证失败
    console.log(departmentProps);
    // return;
    //提交表单
    if (departmentProps.opt == FormOptEnum.ADD) {
      await userManageDepartmentApi
        .add(departmentProps.record, departmentProps.record.id != undefined)
        .then(() => {
          departmentProps.successful!(); //调用父组件的successful方法
        })
        .finally(() => {
          onClose();
        });
    } else {
      await userManageDepartmentApi
        .update(departmentProps.record, departmentProps.record.id != undefined)
        .then(() => {
          departmentProps.successful!(); //调用父组件的successful方法
        })
        .finally(() => {
          onClose();
        });
    }
  });
}

/** 关闭表单*/
function onClose() {
  visible.value = false;
}

// 暴露给父组件的方法
defineExpose({
  onOpen
});
</script>

<style lang="scss" scoped></style>
